//------------------------------------------------------------------------------
// OWL Extensions (OWLEXT) Class Library
//  Copyright  1998 by Yura Bidus. All Rights Reserved.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TTipDialog (TDialog).
//
//$Revision: 1.1.2.2 $
//$Author: jogybl $
//$Date: 2007/09/11 10:20:32 $
//------------------------------------------------------------------------------
#if !defined(OWLEXT_TIPDIALG_H) // Sentry, use file only if it's not already included.
#define OWLEXT_TIPDIALG_H


#include <owl/filename.h>

// Grab the core OWLEXT file we need
//
#if !defined (__OWLEXT_CORE_H) && !defined (__OWLEXT_ALL_H)
# include <owlext/core.h>
#endif

OWLEXT_BEGIN_NAMESPACE

// Generic definitions/compiler options (eg. alignment) preceeding the
// definition of classes
#include <owl/preclass.h>

class OWLEXTCLASS TTipDialog : public TDialog {
	public:
		TTipDialog(TWindow *parent, LPCTSTR regkey, TModule* module = 0);

		virtual ~TTipDialog();
		bool ShowOnStartup();

	protected:
		bool		 		ShowDlg;
		bool		 		TipError;
		owl_string	CurrentTip;
		owl_string	RegKey;
#if defined(BI_STD_RTL)    
		std::ifstream 		TipFile;
#else
		ifstream 		TipFile;
#endif
		TFileName		FileName;
		TBitmap* 		BulbBitmap;

	public:
		virtual void SetupWindow ();
		virtual void CleanupWindow ();

	protected:
		virtual void GetNextTipString();
		virtual void OpenTipFile(long pos);
		virtual long CloseTipFile();
		//Get User data from registry or from file, can be overriden
		// to get data from else place
		virtual long ReadSettings();
		//Write User data to registry or to file, can be overriden
		// to get data from else place
		virtual void WriteSettings(long pos);
		virtual owl_string GetTipName();
		virtual TBitmap* GetBitmap();

	protected:
		void EvPaint ();
		void CmNextTip();
		HBRUSH EvCtlColor (HDC hDC, HWND hWndChild, uint ctlType);

	DECLARE_RESPONSE_TABLE(TTipDialog);
	DECLARE_STREAMABLE(OWLEXTCLASS, __OWLEXT TTipDialog, 1);
};

// Generic definitions/compiler options (eg. alignment) following the
// definition of classes
#include <owl/posclass.h>

OWLEXT_END_NAMESPACE

#endif     // OWLEXT_TIPDIALG_H sentry.
